Bug 1025095 - Review Request: rubygem-goocanvas1 - Ruby binding of GooCanvas
Review Request: rubygem-goocanvas1 - Ruby binding of GooCanvas
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ken Dreyer
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1024931
  Show dependency treegraph
 
Reported: 2013-10-30 21:49 EDT by Mamoru TASAKA
Modified: 2013-11-12 03:38 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-11-12 03:38:30 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
ktdreyer: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Mamoru TASAKA 2013-10-30 21:49:26 EDT
Spec URL: http://mtasaka.fedorapeople.org/Review_request/ruby-gnome2-suite/rubygem-goocanvas2.spec
SRPM URL: http://mtasaka.fedorapeople.org/Review_request/ruby-gnome2-suite/rubygem-goocanvas2-2.0.2-1.fc.src.rpm
Description: 
Ruby/GooCanvas is a Ruby binding of GooCanvas.

Fedora Account System Username: mtasaka

Koji scratch build
F-21: http://koji.fedoraproject.org/koji/taskinfo?taskID=6118022
F-20: http://koji.fedoraproject.org/koji/taskinfo?taskID=6118023

Note:
Due to bug 1024931 (i.e. ruby-goocanvas 1.2.x uses gtk2, while
ruby-goocanvas uses gtk3), I am going to keep rubygem-goocanvas on Fedora
use gtk2 (i.e. keep version 1.2.x) and for ruby-goocanvas using gtk3
I will rename it to rubygem-goocanvas"2" on Fedora, as goocanvas on
Fedora renames itself similarly.
Comment 1 Ken Dreyer 2013-10-30 21:58:04 EDT
I can take this review.
Comment 2 Ken Dreyer 2013-10-30 22:16:31 EDT
As I understand it:

1) The alexandria application requires the goocanvas and gtk2 gems.
2) The upstream goocanvas gem has moved on to GTK3.
3) goocanvas 1.2.x is the last goocanvas version that supported gtk2.
4) alexandria cannot work with GTK3.
5) goocanvas has an active upstream, and alexandria does not.

Do I have that right?

Assuming the above statements are true, I'm wondering if we should have a "rubygem-goocanvas12" package instead? That would satisfy alexandria's dependency, while still allowing you to continue to package the latest versions of goocanvas in the main rubygem-goocanvas package.

Otherwise, the roles are reversed: rubygem-goocanvas will be the "old" one, while rubygem-goocanvas2 will be the "new" one, and it could get even weirder when upstream releases version 3.

What do you think?
Comment 3 Mamoru TASAKA 2013-10-30 23:06:01 EDT
Well, actually I am wondering which option to choose.
However as it is expected that upstream (of ruby-gnome2) will
continue to develop rubygem-goocanvas using gtk3, I will
change old goocanvas gem to 12 on Fedora:

Please check:

http://mtasaka.fedorapeople.org/Review_request/ruby-gnome2-suite/rubygem-goocanvas12.spec
http://mtasaka.fedorapeople.org/Review_request/ruby-gnome2-suite/rubygem-goocanvas12-1.2.6-1.fc.src.rpm
Comment 4 Ken Dreyer 2013-10-31 11:33:43 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- After thinking about it a bit more, should this be named simply
  "rubygem-goocanvas1"?

- On line 136, "%exclue	%{gem_cache}" causes the package to fail to build.

- You can remove "%defattr" in %files.

- Since the comment says "CRuby only", should you use "Requires: ruby" instead
  of "Requires: ruby(release)" ? That would match what you've done in
  rubygem-gtk3.

- Package is missing "Requires: ruby(rubygems)"

If you fix these issues I can approve the package.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later) (with incorrect FSF address)", "LGPL (v2)", "LGPL
     (v2.1 or later)", "Unknown or generated". 8 files have unknown license.
     Detailed output of licensecheck in /home/ktdreyer/fedora-scm/rubygem-
     goocanvas-review/review-rubygem-goocanvas12/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by rubygem-goocanvas. I assume that
     mtasaka will push goocanvas version 2 to Fedora 20 once this package is
     accepted, and then the conflict will no longer exist.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[!]: Each %files section contains %defattr if rpm < 4.4
     Note: %defattr present but not needed
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     See caveat above about rubygem-goocanvas 2 on Fedora 20. Once you push
     goocanvas version 2 to Fedora 20, the conflict will go away.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
     "Require: ruby" instead of "Require: ruby(release)"
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir_mri}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Macro %{gem_extdir} is deprecated.
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Package does not contain Requires: ruby(abi).
[x]: Package contains Requires: ruby(release).

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[-]: Latest version is packaged.
     Not applicable: this is specifically an older version to support alexandria
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Ruby:
[x]: Specfile should use macros from rubygem-devel package.
[x]: Gem package should exclude cached Gem.
[x]: Gem should use %gem_install macro.
[x]: Test suite of the library should be run.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-goocanvas12-1.2.6-1.fc20.i686.rpm
          rubygem-goocanvas12-doc-1.2.6-1.fc20.i686.rpm
          rubygem-goocanvas12-devel-1.2.6-1.fc20.i686.rpm
          rubygem-goocanvas12-1.2.6-1.fc20.src.rpm
rubygem-goocanvas12.i686: W: no-soname /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so
rubygem-goocanvas12-doc.i686: W: no-documentation
rubygem-goocanvas12-doc.i686: E: incorrect-fsf-address /usr/share/gems/gems/goocanvas-1.2.6/sample/demo.rb
rubygem-goocanvas12-doc.i686: E: incorrect-fsf-address /usr/share/gems/gems/goocanvas-1.2.6/sample/demo-primitives.rb
rubygem-goocanvas12-doc.i686: E: incorrect-fsf-address /usr/share/gems/gems/goocanvas-1.2.6/sample/demo-fifteen.rb
rubygem-goocanvas12-devel.i686: W: spelling-error %description -l en_US goocanvas -> goo canvas, goo-canvas, canvass
rubygem-goocanvas12-devel.i686: W: no-documentation
rubygem-goocanvas12.src: W: strange-permission rubygem-goocanvas12.spec 0600L
4 packages and 0 specfiles checked; 3 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint rubygem-goocanvas12-doc rubygem-goocanvas12 rubygem-gooca 
nvas12-devel
rubygem-goocanvas12-doc.i686: W: no-documentation
rubygem-goocanvas12-doc.i686: E: incorrect-fsf-address /usr/share/gems/gems/goocanvas-1.2.6/sample/demo.rb
rubygem-goocanvas12-doc.i686: E: incorrect-fsf-address /usr/share/gems/gems/goocanvas-1.2.6/sample/demo-primitives.rb
rubygem-goocanvas12-doc.i686: E: incorrect-fsf-address /usr/share/gems/gems/goocanvas-1.2.6/sample/demo-fifteen.rb
rubygem-goocanvas12.i686: W: no-soname /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_id_children
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_make_enum
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_define_class
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbglib_num_to_uint64
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_instance_from_ruby_object
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbg_define_method
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_remove_relative
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgtk_initialize_gtkobject
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_initialize_object
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgutil_glist2ary_and_free
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rb_cairo_matrix_from_ruby_object
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_add_relative_removable
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_gvalue_to_rvalue
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbglib_num_to_int64
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rb_cairo_pattern_from_ruby_object
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rb_cairo_context_from_ruby_object
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_add_constants
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_get_flags
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_ruby_object_from_instance
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_boxed_get
rubygem-goocanvas12.i686: W: undefined-non-weak-symbol /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so rbgobj_get_enum
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/libcairo.so.2
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/libpango-1.0.so.0
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/libpangocairo-1.0.so.0
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/libatk-1.0.so.0
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/libgio-2.0.so.0
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/libpangoft2-1.0.so.0
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/libfreetype.so.6
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/libfontconfig.so.1
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/libpthread.so.0
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/librt.so.1
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/libdl.so.2
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/libcrypt.so.1
rubygem-goocanvas12.i686: W: unused-direct-shlib-dependency /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so /lib/libm.so.6
rubygem-goocanvas12-devel.i686: W: spelling-error %description -l en_US goocanvas -> goo canvas, goo-canvas, canvass
rubygem-goocanvas12-devel.i686: W: no-documentation
3 packages and 0 specfiles checked; 3 errors, 38 warnings.
# echo 'rpmlint-done:'



Requires
--------
rubygem-goocanvas12-doc (rpmlib, GLIBC filtered):
    rubygem-goocanvas12(x86-32)

rubygem-goocanvas12 (rpmlib, GLIBC filtered):
    libatk-1.0.so.0
    libc.so.6
    libcairo.so.2
    libcrypt.so.1
    libdl.so.2
    libfontconfig.so.1
    libfreetype.so.6
    libgdk-x11-2.0.so.0
    libgdk_pixbuf-2.0.so.0
    libgio-2.0.so.0
    libglib-2.0.so.0
    libgobject-2.0.so.0
    libgoocanvas.so.3
    libgtk-x11-2.0.so.0
    libm.so.6
    libpango-1.0.so.0
    libpangocairo-1.0.so.0
    libpangoft2-1.0.so.0
    libpthread.so.0
    librt.so.1
    libruby.so.2.0
    rtld(GNU_HASH)
    ruby(release)
    rubygem(cairo)
    rubygem(gtk2)

rubygem-goocanvas12-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    rubygem-goocanvas12(x86-32)



Provides
--------
rubygem-goocanvas12-doc:
    rubygem-goocanvas12-doc
    rubygem-goocanvas12-doc(x86-32)

rubygem-goocanvas12:
    rubygem(goocanvas)
    rubygem-goocanvas12
    rubygem-goocanvas12(x86-32)

rubygem-goocanvas12-devel:
    pkgconfig(ruby-goocanvas12)
    rubygem-goocanvas12-devel
    rubygem-goocanvas12-devel(x86-32)



Unversioned so-files
--------------------
rubygem-goocanvas12: /usr/lib/gems/ruby/goocanvas-1.2.6/lib/goocanvas.so

Source checksums
----------------
https://rubygems.org/gems/goocanvas-1.2.6.gem :
  CHECKSUM(SHA256) this package     : 8e7e95e2e2f38ba1bbd53932ab10d12213c5def3c81c3d53e97ec678abe26839
  CHECKSUM(SHA256) upstream package : 8e7e95e2e2f38ba1bbd53932ab10d12213c5def3c81c3d53e97ec678abe26839


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -n rubygem-goocanvas12 -m fedora-20-i386
Buildroot used: fedora-20-i386
Active plugins: Generic, Ruby, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 5 Mamoru TASAKA 2013-10-31 20:54:47 EDT
Thank you for comments. I think I have incorporated your comments in
the new srpm:

http://mtasaka.fedorapeople.org/Review_request/ruby-gnome2-suite/rubygem-goocanvas1.spec
http://mtasaka.fedorapeople.org/Review_request/ruby-gnome2-suite/rubygem-goocanvas1-1.2.6-2.fc.src.rpm

* Fri Nov  1 2013 Mamoru TASAKA <mtasaka@fedoraproject.org> - 1.2.6-2
- Incorporate comments on review request (bug 1025095)
Comment 6 Ken Dreyer 2013-11-01 02:03:12 EDT
Looks good to me! Package approved.
Comment 7 Mamoru TASAKA 2013-11-01 04:45:53 EDT
Thank you! I will surely review your package later.

Thank you!

New Package SCM Request
=======================
Package Name: rubygem-goocanvas1
Short Description: Ruby binding of GooCanvas
Owners: mtasaka
Branches: f20
Comment 8 Gwyn Ciesla 2013-11-01 08:13:39 EDT
Git done (by process-git-requests).
Comment 9 Mamoru TASAKA 2013-11-12 03:38:30 EST
Rebuilt on all branches, push requested on F-20 and F-19, closing.

Thank you for review and git procedure.

Note You need to log in before you can comment on or make changes to this bug.